/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * OSOYOO building block car lesson 4 - Bluetooth Control
 * tutorial: https://osoyoo.com/?p=49737
 * CopyRight www.osoyoo.com
 */
#include <PWMServo.h>
#define IN1 11 //IN1 to D11
#define IN2 12 //IN2 to D12
#define ENA 5  //  ENA pin to D5
#define SERVO_PIN 9 //steer servo to D9
#define LEFT_LIGHT 4 //  left light to D4
#define RIGHT_LIGHT 13 //  right light to D13
#define SOFT_RX 2  //  Bluetooh B_TX pin to D2 (Soft RX)
#define SOFT_TX 3  //  Bluetooh B_RX pin to D3 (Soft TX)
#define MAX_PACKETSIZE 32    //Serial receive buffer
char buffUART[MAX_PACKETSIZE];
unsigned int buffUARTIndex = 0;
unsigned long preUARTTick = 0;
struct car_status{
  int speed;
  int angle;
  int direct;
};

#ifndef HAVE_HWSERIAL1
#include "SoftwareSerial.h"
SoftwareSerial Serial1(SOFT_RX, SOFT_TX); // B_TX, B_RX
#endif
#define FRONT 90        // 90 degree means steering to front 
int RIGHT=FRONT+28 ;
int LEFT=FRONT-28;
int SHARP_RIGHT=FRONT+38;
int SHARP_LEFT=FRONT-40;
#define MIN_SPEED 120     
#define BACK_TIME 1000  
int SPEED=0;
 
PWMServo head;
/*motor control*/
void go_Back(int speed)  //Forward
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2,LOW); 
  analogWrite(ENA,speed);
  digitalWrite(RIGHT_LIGHT,HIGH);
  digitalWrite(LEFT_LIGHT,HIGH); 
  delay (200);
  digitalWrite(RIGHT_LIGHT,LOW);
  digitalWrite(LEFT_LIGHT,LOW); 
  delay (200);
  digitalWrite(RIGHT_LIGHT,HIGH);
  digitalWrite(LEFT_LIGHT,HIGH); 
  delay (200);
  digitalWrite(RIGHT_LIGHT,LOW);
  digitalWrite(LEFT_LIGHT,LOW); 
  delay (200);
}
 
void  go_Advance(int speed)  //Forward
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,HIGH); 
  analogWrite(ENA,speed);
 
}
 
void turn(int angle)
{

  head.write(angle);

}
 
void stop_Stop()    //Stop
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,LOW);
  analogWrite(ENA,0);
  digitalWrite(RIGHT_LIGHT,HIGH);
  digitalWrite(LEFT_LIGHT,HIGH); 
}

  
void setup() {

 pinMode(ENA, OUTPUT); 
 pinMode(IN1, OUTPUT); 
 pinMode(IN2, OUTPUT); 

 head.attach(SERVO_PIN);
 turn(FRONT);  // Steering to front
 Serial.begin(9600);
Serial1.begin(9600);
}
void do_Uart_Tick()
{

  char Uart_Date=0;
  if(Serial1.available()) 
  {
    size_t len = Serial1.available();
    uint8_t sbuf[len + 1];
    sbuf[len] = 0x00;
    Serial1.readBytes(sbuf, len);
    //parseUartPackage((char*)sbuf);
    memcpy(buffUART + buffUARTIndex, sbuf, len);//ensure that the serial port can read the entire frame of data
    buffUARTIndex += len;
    preUARTTick = millis();
    if(buffUARTIndex >= MAX_PACKETSIZE - 1) 
    {
      buffUARTIndex = MAX_PACKETSIZE - 2;
      preUARTTick = preUARTTick - 200;
    }
  }
  car_status cs;
  if(buffUARTIndex > 0 && (millis() - preUARTTick >= 100))//APP send flag to modify the obstacle avoidance parameters
  { //data ready
    buffUART[buffUARTIndex] = 0x00;
    Uart_Date=buffUART[0];
    cs=get_status(buffUART);
    buffUARTIndex = 0;
  }
   SPEED=cs.speed+MIN_SPEED;

   if (SPEED>250) SPEED=250;
    
   

  switch (Uart_Date)    //serial control instructions
  {
    Serial.print("data=");
    Serial.println(Uart_Date);
    case 'M':  
    go_Advance(SPEED);
    turn(FRONT);
    break;
    case 'L':  
    digitalWrite(RIGHT_LIGHT,LOW); 
    digitalWrite(LEFT_LIGHT,HIGH); 
    if(cs.angle=1){
       turn(LEFT);
       
    }
    if(cs.angle=2){
       turn(SHARP_LEFT);
    }
    break;
    case 'R': 
    digitalWrite(RIGHT_LIGHT,HIGH); 
    digitalWrite(LEFT_LIGHT,LOW); 
    if(cs.angle=-1){
       turn(RIGHT);
    }
    if(cs.angle=-2){
      turn(SHARP_RIGHT);
    }
    break;
    case 'B':  
    go_Back(SPEED); 
    break;
    case 'X': 
    go_Back(SPEED);
    if(cs.angle=-1){
       turn(LEFT);;
    }
    if(cs.angle=-2){
       turn(SHARP_LEFT);;
    }
    break;
    case 'Y':  
    go_Back(SPEED); 
    if(cs.angle=1){
       turn(RIGHT);
    }
    if(cs.angle=2){
      turn(SHARP_RIGHT);
    }
    break;
 
    case 'E': stop_Stop() ;break;
    case 'J': stop_Stop() ;break;
    default:break;
  }
}
car_status get_status( char buffUART[])
{
  car_status cstatus;
  int index=2;
  if (buffUART[index]=='-'){
    cstatus.angle=-buffUART[index+1]+'0';
    index=index+3;
    
  } else {
   
    cstatus.angle=buffUART[index]-'0';
     index=index+2;
  }
  int currentvalue;
  int spd=0;
  while (buffUART[index]!=',')
  {
    currentvalue=buffUART[index]-'0';
    spd=spd*10+currentvalue;
    index++;
  }
  cstatus.speed=spd;
  index++;
  cstatus.direct=buffUART[index]-'0';
  return cstatus;
}
void loop() {
 do_Uart_Tick();
}
